<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>gateway documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">gateway documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content interface">
                   <div class="content-data">












<ol class="breadcrumb">
  <li>Interfaces</li>
  <li>IPOJO</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/common/utility/pipe-utility.ts</code>
        </p>





            <section>
    <h3 id="inputs">Indexable</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <code>[key: string]:        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>
</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="51" class="link-to-prism">src/common/utility/pipe-utility.ts:51</a></div>
                            </td>
                        </tr>
            </tbody>
        </table>
</section>

    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">export const pipe &#x3D; &lt;T extends any[], R&gt;(
    fn1: (...args: T) &#x3D;&gt; R,
    ...fns: Array&lt;(a: R) &#x3D;&gt; R&gt;
) &#x3D;&gt; {
    const piped &#x3D; fns.reduce(
        (prevFn, nextFn) &#x3D;&gt; (value: R) &#x3D;&gt; nextFn(prevFn(value)),
        value &#x3D;&gt; value
    )
    return (...args: T) &#x3D;&gt; piped(fn1(...args))
}

export const valuePairsToObject &#x3D; (obj: {
    [key: string]: any,
    prop: string,
    value: any,
}[]) &#x3D;&gt; {
    return obj.reduce((acc, curr) &#x3D;&gt; {
        return {
            ...acc,
            [curr.prop]: curr.value
        }
    }, {})
}

interface IValuePair {
    prop: string
    value: any
}

export const objectToValuePairs &#x3D; (
    obj: any,
): IValuePair[] &#x3D;&gt; {
    let entries &#x3D; Object.entries(obj)
    let pair: IValuePair[] &#x3D; entries.reduce((prev: any, curr: any) &#x3D;&gt; {
        return [
            ...prev,
            {
                prop: curr[0],
                value: curr[1],
            }
        ]
    }, [])
    return pair
}

interface IPOJO {
    [key: string]: any
}

export const mergeObjects &#x3D; (...obj: object[]) &#x3D;&gt; {
    return obj.reduce((acc, curr) &#x3D;&gt; {
        return {
            ...acc,
            ...curr
        }
    }, {})
}

export const removeUndefinedFromObject &#x3D; &lt;T&gt;(obj: T): Partial&lt;T&gt; &#x3D;&gt; {
    return Object.keys(obj).reduce((acc, key) &#x3D;&gt; {
        const _acc &#x3D; acc;
        if (obj[key] !&#x3D;&#x3D; undefined) {
            _acc[key] &#x3D; obj[key]
        }
        return _acc;
    }, {})
}

export const renameObject &#x3D; (
    arr: object,
    newName: string,
) &#x3D;&gt; {
    return Object.entries(arr).reduce((prev, curr) &#x3D;&gt; {
        return {
            ...prev,
            [&#x60;${newName}${curr[0]}&#x60;]: curr[1]
        }
    }, {})
}</code></pre>
    </div>
</div>


                   




                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'interface';
            var COMPODOC_CURRENT_PAGE_URL = 'IPOJO.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
